
# --
# The following check for program_invocation_* and sys_errlis
    
AC_DEFUN(AC_VAR_PROGRAM_INVOCATION,[
  AC_MSG_CHECKING([for program_invocation_name])
  AC_TRY_LINK([int *p;],
    [ extern int program_invocation_name; p = &program_invocation_name ],
    [ AC_DEFINE(HAVE_PROGRAM_INVOCATION_NAME, 1, [Define if we use GNU C])
      AC_MSG_RESULT(yes) ],
    [ AC_MSG_RESULT(no) ])
  AC_MSG_CHECKING([for program_invocation_short_name])
  AC_TRY_LINK([int *p;],
    [ extern int program_invocation_short_name; 
      p = &program_invocation_short_name; ],
    [ AC_DEFINE(HAVE_PROGRAM_INVOCATION_SHORT_NAME, 1, [Define if we use GNU C])
      AC_MSG_RESULT(yes) ],
    [ AC_MSG_RESULT(no) ])
])

AC_DEFUN(jm_FUNC_MALLOC,
[
 if test x = y; then
   dnl This code is deliberately never run via ./configure.
   dnl FIXME: this is a gross hack to make autoheader put an entry
   dnl for this symbol in config.h.in.
   AC_CHECK_FUNCS(DONE_WORKING_MALLOC_CHECK)
 fi
 dnl xmalloc.c requires that this symbol be defined so it doesnt
 dnl mistakenly use a broken malloc -- as it might if this test were omitted.
 ac_kludge=HAVE_DONE_WORKING_MALLOC_CHECK
 AC_DEFINE_UNQUOTED($ac_kludge)

 AC_CACHE_CHECK([for working malloc], jm_cv_func_working_malloc,
  [AC_TRY_RUN([
    char *malloc ();
    int
    main ()
    {
      exit (malloc (0) ? 0 : 1);
    }
	  ],
	 jm_cv_func_working_malloc=yes,
	 jm_cv_func_working_malloc=no,
	 dnl When crosscompiling, assume malloc is broken.
	 jm_cv_func_working_malloc=no)
  ])
  if test $jm_cv_func_working_malloc = no; then
    LIBOBJS="$LIBOBJS malloc.o"
    AC_DEFINE_UNQUOTED(malloc, rpl_malloc, [Define if we have a buggy malloc])
  fi
])

AC_DEFUN(jm_FUNC_REALLOC,
[
 if test x = y; then
   dnl This code is deliberately never run via ./configure.
   dnl FIXME: this is a gross hack to make autoheader put an entry
   dnl for this symbol in config.h.in.
   AC_CHECK_FUNCS(DONE_WORKING_REALLOC_CHECK)
 fi
 dnl xmalloc.c requires that this symbol be defined so it doesnt
 dnl mistakenly use a broken realloc -- as it might if this test were omitted.
 ac_kludge=HAVE_DONE_WORKING_REALLOC_CHECK
 AC_DEFINE_UNQUOTED($ac_kludge)

 AC_CACHE_CHECK([for working realloc], jm_cv_func_working_realloc,
  [AC_TRY_RUN([
    char *realloc ();
    int
    main ()
    {
      exit (realloc (0, 0) ? 0 : 1);
    }
	  ],
	 jm_cv_func_working_realloc=yes,
	 jm_cv_func_working_realloc=no,
	 dnl When crosscompiling, assume realloc is broken.
	 jm_cv_func_working_realloc=no)
  ])
  if test $jm_cv_func_working_realloc = no; then
    LIBOBJS="$LIBOBJS realloc.o"
    AC_DEFINE_UNQUOTED(realloc, rpl_realloc, [Define if we have a buggy realloc])
  fi
])


# --
# The following are needed for alloca.c
AC_HEADER_STDC
AC_CHECK_HEADERS(stdlib.h string.h strings.h)
AC_FUNC_ALLOCA
jm_FUNC_MALLOC
jm_FUNC_REALLOC

# The following are needed for the parg library
AC_VAR_PROGRAM_INVOCATION 

# The following are needed for dstring.c 
# headers: string.h 

# the xmalloc stuff 
# The following is needed for xmalloc.c 
AC_TYPE_SIZE_T

# The following stuff is needed for handling errors
AC_CHECK_FUNCS(strerror strerror_r)
AC_FUNC_VPRINTF
AM_FUNC_ERROR_AT_LINE

# The following is needed for GNU getopt
AC_CHECK_FUNCS(getopt_long,,LIBOBJS="$LIBOBJS getopt.o getopt1.o")

# The following is needed to get memcpy, vasprint
AC_REPLACE_FUNCS(memcpy strtol strtoul vasprintf)
AM_FUNC_STRTOD

# The following is needed to get vprintf
AC_FUNC_VPRINTF
