/*
** Copyright (C) 1999 Eleftherios Gkioulekas <lf@amath.washington.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#if HAVE_CONFIG_H
# include <config.h>
#endif
#include <stdio.h>
#include <parg.h>

int 
main (int argc, char *argv[])
{
  struct parg *parser;
  int n;
  long int arg1;
  double arg2;
  char *response;

  /* Documentation string */
  parg_program_bug_address = "<lf@amath.washington.edu>";
  parg_program_documentation = "Numbers -- A demonstration of reliable number "
    "parsing.\v"
    "This program takes an integer ARG1 and a real number ARG2, parses them "
    "and if they parse okey, prints them back. Otherwise it raises an error "
    "message.";
  parg_program_arguments = "ARG1 ARG2";
  
  /* Parse the command-line arguments */
  parg_set_invocation (argv[0], PACKAGE, VERSION);
  parser = parg_parse (argc, argv, NULL);

  /* Check that we have two arguments */
  n = parg_argument_count (parser);
  if (n > 2) parg_error (parser, "Too many arguments!");
  if (n < 2) parg_error (parser, "Too few arguments!"); 
   
  /* Parse the arguments */
  arg1 = parg_string_to_integer (parg_argument (parser, 1));
  arg2 = parg_string_to_double (parg_argument (parser, 2));

  /* Print the arguments -- and demonstrate asprintf */
  asprintf (&response, "The integer is %d\nThe real number is %f\n",
	     arg1, arg2);
  printf (response);
  free (response);
  return 0;
}
