/*
** The minimal hello world program
** Copyright (C) 1998 Eleftherios Gkioulekas <lf@amath.washington.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#if HAVE_CONFIG_H
# include <config.h>
#endif
#include <stdio.h>
#include <parg.h>

/*
 * This is the minimal hello world program. The minimal overhead of using
 * parg for option parsing is to invoke parg_set_invocation to declare
 * the identity of your package and an invocation to parg_parse. 
 * Since there are no user-defined options, we pass NULL which is allowed.
 * Then the program can go about its bussiness
 */

int main (int argc, char *argv[])
{
  parg_set_invocation (argv[0], PACKAGE, VERSION);
  parg_parse (argc, argv, NULL);
  printf ("Hello world\n");
}
