/*
** The minimal hello world program
** Copyright (C) 1998 Eleftherios Gkioulekas <lf@amath.washington.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#if HAVE_CONFIG_H
# include <config.h>
#endif
#include <stdio.h>
#include <parg.h>

/*
 * In order for a program to conform to GNITS standards, it needs to at
 * at least define a bug address and a documentation string, as in this
 * example. This makes the --help output more useful. The documentation string
 * will be formatted to fit your screen automatically. So you should just
 * worry about fitting it in your source code and let the parg handle the
 * rest.
 */

int main (int argc, char *argv[])
{
  parg_program_bug_address = "<lf@amath.washington.edu>";
  parg_program_documentation = "Parg example 2 -- A fully GNITS compliant "
    "application.\v"
    "This application does nothing interesting. It simply says hello to the "
    "world, through your screen. To use this application, run it, read the "
    "output, and then wave your hand in front of your computer. If you are "
    "lucky, the computer might bring out a hand through the monitor and wave "
    "its greetings back at you. Then again, computers are not known for "
    "exposing their private parts.";
    
  parg_set_invocation (argv[0], PACKAGE, VERSION);
  parg_parse (argc, argv, NULL);
  printf ("Hello world\n");
}
