/*
** The minimal hello world program
** Copyright (C) 1998 Eleftherios Gkioulekas <lf@amath.washington.edu>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#if HAVE_CONFIG_H
# include <config.h>
#endif
#include <stdio.h>
#include <parg.h>

/*
 * Some GNITS conforming programs, may not take options but they might
 * want to take a look at command-line arguments. In that case, GNITS
 * requires that you provide a usage string for the arguments.
 */

int main (int argc, char *argv[])
{
  struct parg *parser;
  int i,n;

  parg_program_bug_address = "<lf@amath.washington.edu>";
  parg_program_documentation = "Parg example 3 -- A friendly hello world "
    "application.\v"
    "This program says hello to NAME, if it is given. If more than one "
    "arguments are given, it says hello to each and every one of them. "
    "If no arguments are given, it says hello to the entire world.";
  parg_program_arguments = "NAME ...";

  /* Standard invocation of the parser. 
     Note that we know do care about the return value of parg_parse */
  parg_set_invocation (argv[0], PACKAGE, VERSION);
  parser = parg_parse (argc, argv, NULL);

  /* Get the number of arguments */
  n = parg_argument_count (parser);
  if (n == 0)
    {
      printf ("Hello world\n");
    } 
  else
    {
      for (i=1; i<=n; i++)
	{
	  printf ("Hello %s \n", parg_argument (parser, i));
	}
      printf ("Nice meeting you.\n");
    }
}
